<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Payments</title>

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
    <!-- DataTables -->
    <link rel="stylesheet" href="plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
    <link rel="stylesheet" href="plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
    <link rel="stylesheet" href="plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">
</head>

<body class="hold-transition sidebar-mini">
    <div class="wrapper">
        <!-- Main Sidebar Container -->
        <aside class="main-sidebar sidebar-dark-primary elevation-4">
            <!-- Brand Logo -->
            <a href="index3.html" class="brand-link">
                <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
                <span class="brand-text font-weight-light">Pizza Project</span>
            </a>

            <!-- Sidebar -->
            <div class="sidebar">
                <!-- Sidebar user (optional) -->
                <div class="user-panel mt-3 pb-3 mb-3 d-flex">
                    <div class="image">
                        <img src="dist/img/user3-128x128.jpg" class="img-circle elevation-2" alt="User Image">
                    </div>
                    <div class="info">
                        <a href="#" class="d-block">Linh Giang</a>
                    </div>
                </div>

                <!-- Sidebar Menu -->
                <nav class="mt-2">
                    <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
                        <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
                        <li class="nav-item menu-open">
                            <a href="#" class="nav-link active">
                                <i class="nav-icon fas fa-table"></i>
                                <p>
                                    Quản trị
                                    <i class="fas fa-angle-left right"></i>
                                </p>
                            </a>
                            <ul class="nav nav-treeview">
                                <li class="nav-item">
                                    <a href="customers.html" class="nav-link">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Customers</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="payments.html" class="nav-link active">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Payments</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="orders.html" class="nav-link">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Orders</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="orderdetails.html" class="nav-link">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Order Details</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="products.html" class="nav-link">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Products</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="productlines.html" class="nav-link">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Product Lines</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="employees.html" class="nav-link">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Employees</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="offices.html" class="nav-link">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Offices</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="filterorders.html" class="nav-link">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Filter Orders</p>
                                    </a>
                                </li>
                            </ul>
                        </li>
                    </ul>
                </nav>
                <!-- /.sidebar-menu -->
            </div>
            <!-- /.sidebar -->
        </aside>

        <!-- Content Wrapper. Contains page content -->
        <div class="content-wrapper">
            <!-- Content Header (Page header) -->
            <section class="content-header">
                <div class="container-fluid">
                    <div class="row mb-2">
                        <div class="col-sm-12 text-center">
                            <h1>Quản trị Payments</h1>
                        </div>
                    </div>
                </div>
                <!-- /.container-fluid -->
            </section>
            <!-- Main content -->
            <section class="content">
                <div class="container-fluid">
                    <div class="row">
                        <div class="col-12">
                            <div class="card">
                                <div class="card-body">
                                    <div class="container-fluid">

                                        <button id="btn-create-payment" class="btn btn-success">Thêm Payments mới</button>

                                    </div>
                                    <hr class="border">
                                    <h3 class="text-center">Payments Table</h3>
                                    <table class="table table-bordered table-striped table-hover text-center" id="payment-table">
                                        <thead>
                                            <tr>
                                                <th>STT</th>
                                                <th>Customer Name</th>
                                                <th>Check Number</th>
                                                <th>Payment Date</th>
                                                <th>Ammount</th>
                                                <th>Action</th>
                                            </tr>
                                            <tbody>

                                            </tbody>
                                    </table>
                                    <!-- modal create order-->
                                    <div class="modal" id="modal-create-payment" tabindex="-1" role="dialog">
                                        <div class="modal-dialog" role="document">
                                            <div class="modal-content">
                                                <div class="modal-header">
                                                    <h5 class="modal-title">Tạo Payment mới</h5>
                                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                                         <span aria-hidden="true">&times;</span>
                                                    </button>
                                                </div>
                                                <div class="modal-body">
                                                    <div class="col-12">
                                                        <div class="row form-group">
                                                            <div class="col-4">
                                                                <label for="" class="font-weight-bold">Customer ID</label>
                                                            </div>
                                                            <div class="col-8">
                                                                <input type="text" id="inp-create-customer-id" class="form-control" disabled>
                                                            </div>
                                                        </div>
                                                    </div>
                                                    <div class="col-12">
                                                        <div class="row form-group">
                                                            <div class="col-4">
                                                                <label for="" class="font-weight-bold">Check Number</label>
                                                            </div>
                                                            <div class="col-8">
                                                                <input type="text" id="inp-create-check-number" class="form-control">
                                                            </div>
                                                        </div>
                                                    </div>
                                                    <div class="col-12">
                                                        <div class="row form-group">
                                                            <div class="col-4">
                                                                <label for="" class="font-weight-bold">Payment Date</label>
                                                            </div>
                                                            <div class="col-8">
                                                                <input type="date" id="inp-create-payment-date" class="form-control">
                                                            </div>
                                                        </div>
                                                    </div>
                                                    <div class="col-12">
                                                        <div class="row form-group">
                                                            <div class="col-4">
                                                                <label for="" class="font-weight-bold">Ammount</label>
                                                            </div>
                                                            <div class="col-8">
                                                                <input type="text" id="inp-create-ammount" class="form-control">
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>

                                                <div class="modal-footer">
                                                    <button type="button" class="btn btn-success confirm-create">Tạo mới</button>
                                                    <button type="button" class="btn btn-danger cancel-create" data-dismiss="modal">Hủy</button>
                                                </div>
                                            </div>
                                        </div>
                                    </div>

                                    <!-- modal update order -->
                                    <div class="modal" id="modal-update-payment" tabindex="-1" role="dialog">
                                        <div class="modal-dialog" role="document">
                                            <div class="modal-content">
                                                <div class="modal-header">
                                                    <h5 class="modal-title">Cập nhật Payment</h5>
                                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                                        <span aria-hidden="true">&times;</span>
                                                    </button>
                                                </div>
                                                <div class="modal-body">
                                                    <div class="col-12">
                                                        <div class="row form-group">
                                                            <div class="col-4">
                                                                <label for="" class="font-weight-bold">ID</label>
                                                            </div>
                                                            <div class="col-8">
                                                                <input type="text" id="inp-update-payment-id" class="form-control">
                                                            </div>
                                                        </div>
                                                    </div>
                                                    <div class="col-12">
                                                        <div class="row form-group">
                                                            <div class="col-4">
                                                                <label for="" class="font-weight-bold">Customer ID</label>
                                                            </div>
                                                            <div class="col-8">
                                                                <input type="text" id="inp-update-customer-id" class="form-control" disabled>
                                                            </div>
                                                        </div>
                                                    </div>
                                                    <div class="col-12">
                                                        <div class="row form-group">
                                                            <div class="col-4">
                                                                <label for="" class="font-weight-bold">Check number</label>
                                                            </div>
                                                            <div class="col-8">
                                                                <input type="text" id="inp-update-check-number" class="form-control">
                                                            </div>
                                                        </div>
                                                    </div>
                                                    <div class="col-12">
                                                        <div class="row form-group">
                                                            <div class="col-4">
                                                                <label for="" class="font-weight-bold">Payment Date</label>
                                                            </div>
                                                            <div class="col-8">
                                                                <input type="text" id="inp-update-payment-date" class="form-control">
                                                            </div>
                                                        </div>
                                                    </div>
                                                    <div class="col-12">
                                                        <div class="row form-group">
                                                            <div class="col-4">
                                                                <label for="" class="font-weight-bold">Ammount</label>
                                                            </div>
                                                            <div class="col-8">
                                                                <input id="inp-update-ammount" class="form-control">
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>

                                                <div class="modal-footer">
                                                    <button type="button" class="btn btn-success confirm-update">Cập nhật</button>
                                                    <button type="button" class="btn btn-danger cancel-update" data-dismiss="modal">Hủy</button>
                                                </div>
                                            </div>
                                        </div>
                                    </div>

                                    <!-- modal xóa order -->
                                    <div class="modal" tabindex="-1" role="dialog" id="modal-delete-payment">
                                        <div class="modal-dialog" role="document">
                                            <div class="modal-content">
                                                <div class="modal-header">
                                                    <h5 class="modal-title">Xóa Payment</h5>
                                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                    <span aria-hidden="true">&times;</span>
                                </button>
                                                </div>
                                                <div class="modal-body">
                                                    <p>Bạn có muốn xóa Payment này không?</p>
                                                </div>
                                                <div class="modal-footer">
                                                    <button type="button" class="btn btn-primary" id="btn-confirm-delete">Xác nhận</button>
                                                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Hủy</button>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <hr>
                            </div>
                        </div>
                    </div>
                    <!-- /.card -->
                </div>
                <!-- /.col -->
        </div>
        <!-- /.row -->
    </div>
    <!-- /.container-fluid -->
    </section>
    <!-- /.content -->
    </div>
    </div>
    <!-- ./wrapper -->

    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <!-- DataTables  & Plugins -->
    <script src="plugins/datatables/jquery.dataTables.min.js"></script>
    <script src="plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
    <script src="plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
    <script src="plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
    <script src="plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
    <script src="plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
    <script src="plugins/jszip/jszip.min.js"></script>
    <script src="plugins/pdfmake/pdfmake.min.js"></script>
    <script src="plugins/pdfmake/vfs_fonts.js"></script>
    <script src="plugins/datatables-buttons/js/buttons.html5.min.js"></script>
    <script src="plugins/datatables-buttons/js/buttons.print.min.js"></script>
    <script src="plugins/datatables-buttons/js/buttons.colVis.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.min.js"></script>
</body>
<script>
    $(document).ready(function() {
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        //định nghĩa table country
        const gCOL_PAYMENT_ID = 0;
        const gCOL_CUSTOMER_NAME = 1;
        const gCOL_PAYMENT_CHECK_NUMBER = 2;
        const gCOL_PAYMENT_DATE = 3;
        const gCOL_PAYMENT_AMMOUNT = 4;
        const gCOL_PAYMENT_ACTION = 5;

        var gSTT = 1;
        var gPaymentId = 0;
        var gCustomerId = 0;
        var gCustomerSelectedId = 0;
        var gCustomerName = "";
        var gCustomer = [];
        var gCustomerDetail = [];
        const gCOLS = ["id", "customerName", "checkNumber", "paymentDate", "ammount", "action"];
        var gTablePayment = $("#payment-table").DataTable({
            columns: [{
                data: gCOLS[gCOL_PAYMENT_ID]
            }, {
                data: gCOLS[gCOL_CUSTOMER_NAME]
            }, {
                data: gCOLS[gCOL_PAYMENT_CHECK_NUMBER]
            }, {
                data: gCOLS[gCOL_PAYMENT_DATE]
            }, {
                data: gCOLS[gCOL_PAYMENT_AMMOUNT]
            }, {
                data: gCOLS[gCOL_PAYMENT_ACTION]
            }],
            columnDefs: [{
                targets: gCOL_PAYMENT_ID,
                render: function() {
                    return gSTT++;
                }
            }, {
                "targets": gCOL_CUSTOMER_NAME,
                render: function() {
                    return gCustomerName;
                }
            }, {
                "targets": gCOL_PAYMENT_ACTION,
                "defaultContent": `<i class="far fa-edit edit-payment" style= "color : green ; cursor: pointer;" title="Edit " ></i>  
                                <i class="fas fa-trash-alt delete-payment" style= "color : red ; cursor: pointer;" title="Delete"></i>`
            }],
            searching: false,
        });

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

        onPageLoading();
        //Gán event handler khi click vào hàng bất kỳ
        $("#payment-table").on("click", "td", function() {
            onPaymentTableRowClick(this);
        });

        // gán sự kiện cho nút add payment
        $("#btn-create-payment").on("click", function() {
            $("#modal-create-payment").modal("show");
            $("#inp-create-customer-id").val(gCustomerId);
        });
        // confirm payment create
        $(document).on("click", ".confirm-create", function() {
            onBtnCreatePaymentClick();
        });
        // cancel payment create
        $(".cancel-create").on("click", function() {
            $("#modal-create-payment").modal("hide");
        });
        // gán sự kiện cho nút update payment
        $(document).on("click", ".edit-payment", function() {
            $("#modal-update-payment").modal("show");
            onPaymentTableRowClick(this);
        });
        // confirm payment update
        $(".confirm-update").on("click", function() {
            onBtnUpdatePaymentClick();
        });
        // cancel payment update
        $(".cancel-update").on("click", function() {
            $("#modal-update-payment").modal("hide");
        });

        // gán sự kiện cho nút delete payment
        $(document).on("click", ".delete-payment", function() {
            $("#modal-delete-payment").modal("show");
            onPaymentTableRowClick(this);
        });
        // delete payment confirm
        $("#btn-confirm-delete").on("click", function() {
            onBtnDeletePaymentClick();
        });
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        //hàm load trang
        function onPageLoading() {
            "use strict";
            var vUrlString = window.location.href;
            console.log(vUrlString);
            var vUrl = new URL(vUrlString);
            var vGetValueId = vUrl.searchParams.get("customerId");
            const vFORM_LIST_VIEW = "customers.html";
            if (vGetValueId == null || vGetValueId == "") {
                alert("Không có Customer ID");
                window.location.href = vFORM_LIST_VIEW;
            }
            gCustomerId = vGetValueId;
            console.log("customer ID = ", gCustomerId);
            callApiGetPaymentShowOnTable();
            callAjaxApiGetCustomerById(gCustomerId);

        }
        //Hàm thực thi khi click vào hàng bất kỳ
        function onPaymentTableRowClick(paramTableCell) {
            var vClickedRow = $(paramTableCell).parents("tr");
            var vRowData = gTablePayment.row(vClickedRow).data();
            gPaymentId = vRowData.id;
            console.log("Đã click vào row có id là: " + gPaymentId);
            callAjaxApiGetPaymentById(gPaymentId);
        }
        //Hàm gọi API để lấy dữ liệu customer theo id
        function callAjaxApiGetCustomerById(paramId) {
            $.ajax({
                url: "http://localhost:8080/customers/service/detail/" + paramId,
                type: "GET",
                async: false,
                dataType: "json",
                success: function(res) {
                    console.log(res);
                    gCustomerDetail = res;
                    gCustomerName = gCustomerDetail.lastName + " " + gCustomerDetail.firstName;
                    console.log(gCustomerName);
                },
                error: function(err) {
                    console.log(err.responseText);
                }
            })
        }


        //Hàm thực thi khi nhấn nút add payment
        function onBtnCreatePaymentClick() {
            var vObj = {
                checkNumber: $("#inp-create-check-number").val().trim(),
                paymentDate: $("#inp-create-payment-date").val().trim(),
                ammount: $("#inp-create-ammount").val().trim()
            };

            var vCheck = validateCreatePaymentData(vObj);
            if (vCheck == true) {

                $.ajax({
                    url: "http://localhost:8080/payment/service/create/" + gCustomerId,
                    type: "POST",
                    contentType: "application/json",
                    async: false,
                    data: JSON.stringify(vObj),
                    success: function(res) {
                        console.log(res);
                        alert("Tạo Payment mới thành công");
                        window.location.reload();
                    },
                    error: function(err) {
                        console.log(err.responseText);
                    }
                });
            }

        }

        //Hàm thực thi khi nhấn nút update payment
        function onBtnUpdatePaymentClick() {
            "use strict";
            if (gPaymentId == 0) {
                alert("Hãy click chọn Payment cần chỉnh sửa!");
            } else {
                var vObj = {
                    checkNumber: $("#inp-update-check-number").val().trim(),
                    paymentDate: $("#inp-update-payment-date").val().trim(),
                    ammount: $("#inp-update-ammount").val().trim()
                };
            };
            var vCheck = validateUpdatePaymentData(vObj);
            if (vCheck) {
                $.ajax({
                    url: "http://localhost:8080/payment/service/update/" + gPaymentId,
                    type: "PUT",
                    contentType: "application/json; charset=UTF-8",
                    data: JSON.stringify(vObj),
                    success: function(res) {
                        console.log(res);
                        alert("Cập nhật Payment thành công");
                        window.location.reload();
                    },
                    error: function(err) {
                        console.log(err.responseText);
                    }
                });
            };
        }


        //Hàm thực thi khi nhấn nút Delete payment
        function onBtnDeletePaymentClick() {
            "use strict";
            console.log(gPaymentId);
            if (gPaymentId == 0) {
                alert("Hãy click chọn Payment cần xóa!");
            } else {
                $.ajax({
                    url: "http://localhost:8080/payment/service/delete/" + gPaymentId,
                    type: "DELETE",
                    dataType: "json",
                    success: function(res) {
                        console.log(res);
                        alert("Xóa Payment thành công");
                        window.location.reload();
                    },
                    error: function(err) {
                        console.log(err.response);
                    }
                });
            }
        }

        //Hàm gọi APi lấy ra toàn bộ payment theo customer ID
        function callApiGetPaymentShowOnTable() {
            "use strict";
            $.ajax({
                url: "http://localhost:8080/payment/service/customerId/" + gCustomerId,
                type: "GET",
                dataType: "json",
                success: function(res) {
                    console.log(res);
                    gTablePayment.clear();
                    gTablePayment.rows.add(res);
                    gTablePayment.draw();
                },
                error: function(err) {
                    console.log(err.responseText);
                }
            })

        }

        //Hàm gọi API để lấy dữ liệu customer theo id
        function callAjaxApiGetPaymentById(paramId) {
            $.ajax({
                url: "http://localhost:8080/payment/service/detail/" + paramId,
                type: "GET",
                dataType: "json",
                success: function(res) {
                    console.log(res);
                    loadPaymentDataToForm(res);
                },
                error: function(err) {
                    console.log(err.responseText);
                }
            })
        }
        //Hàm load dữ liệu department lên form
        function loadPaymentDataToForm(paramRes) {
            $("#inp-update-payment-id").val(paramRes.id);
            $("#inp-update-customer-id").val(gCustomerId);
            $("#inp-update-check-number").val(paramRes.checkNumber);
            $("#inp-update-payment-date").val(paramRes.paymentDate);
            $("#inp-update-ammount").val(paramRes.ammount);
        }

        //Hàm validate create department
        function validateCreatePaymentData(paramObj) {
            "use strict"
            if (paramObj.checkNumber === "") {
                alert("Hãy nhập Check Number!");
                return false;
            } else if (paramObj.paymentDate === "") {
                alert("Hãy nhập ngày payment");
                return false;
            } else if (paramObj.ammount === "") {
                alert("Hãy nhập ngày ammount");
                return false;
            }
            return true;
        }

        // validate update album
        function validateUpdatePaymentData(paramObj) {
            "use strict"
            if (paramObj.checkNumber === "") {
                alert("Hãy nhập Check Number!");
                return false;
            } else if (paramObj.paymentDate === "") {
                alert("Hãy nhập ngày payment");
                return false;
            } else if (paramObj.ammount === "") {
                alert("Hãy nhập ngày ammount");
                return false;
            }
            return true;
        }

    });
</script>

</html>